# Collator Class Reference

The `Collator` class performs locale-sensitive string comparison. More...

`#include <coll.h>`

Inheritance diagram for Collator:

## Public Types
enum | ECollationStrength { PRIMARY = 0, SECONDARY = 1, TERTIARY = 2, QUATERNARY = 3, IDENTICAL = 15 }
| Base letter represents a primary difference. More...
enum | EComparisonResult { LESS = -1, EQUAL = 0, GREATER = 1 }
| LESS is returned if source string is compared to be less than target string in the compare() method. More...
## Public Member Functions
virtual | ~Collator ()
| Destructor.
virtual UBool | operator== (const Collator &other) const
| Returns true if "other" is the same as "this".
virtual UBool | operator!= (const Collator &other) const
| Returns true if "other" is not the same as "this".
virtual Collator * | clone (void) const =0
| Makes a shallow copy of the current object.
virtual EComparisonResult | compare (const UnicodeString &source, const UnicodeString &target) const
| The comparison function compares the character data stored in two different strings.
virtual UCollationResult | compare (const UnicodeString &source, const UnicodeString &target, UErrorCode &status) const =0
| The comparison function compares the character data stored in two different strings.
virtual EComparisonResult | compare (const UnicodeString &source, const UnicodeString &target, int32_t length) const
| Does the same thing as compare but limits the comparison to a specified length.
virtual UCollationResult | compare (const UnicodeString &source, const UnicodeString &target, int32_t length, UErrorCode &status) const =0
| Does the same thing as compare but limits the comparison to a specified length.
virtual EComparisonResult | compare (const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength) const
| The comparison function compares the character data stored in two different string arrays.
virtual UCollationResult | compare (const UChar *source, int32_t sourceLength, const UChar *target, int32_t targetLength, UErrorCode &status) const =0
| The comparison function compares the character data stored in two different string arrays.
virtual UCollationResult | compare (UCharIterator &sIter, UCharIterator &tIter, UErrorCode &status) const
| Compares two strings using the Collator.
virtual UCollationResult | compareUTF8 (const StringPiece &source, const StringPiece &target, UErrorCode &status) const
| Compares two UTF-8 strings using the Collator.
virtual CollationKey & | getCollationKey (const UnicodeString &source, CollationKey &key, UErrorCode &status) const =0
| Transforms the string into a series of characters that can be compared with CollationKey::compareTo.
virtual CollationKey & | getCollationKey (const UChar *source, int32_t sourceLength, CollationKey &key, UErrorCode &status) const =0
| Transforms the string into a series of characters that can be compared with CollationKey::compareTo.
virtual int32_t | hashCode (void) const =0
| Generates the hash code for the collation object.
virtual const Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const =0
| Gets the locale of the Collator.
UBool | greater (const UnicodeString &source, const UnicodeString &target) const
| Convenience method for comparing two strings based on the collation rules.
UBool | greaterOrEqual (const UnicodeString &source, const UnicodeString &target) const
| Convenience method for comparing two strings based on the collation rules.
UBool | equals (const UnicodeString &source, const UnicodeString &target) const
| Convenience method for comparing two strings based on the collation rules.
virtual ECollationStrength | getStrength (void) const =0
| Determines the minimum strength that will be use in comparison or transformation.
virtual void | setStrength (ECollationStrength newStrength)=0
| Sets the minimum strength to be used in comparison or transformation.
virtual void | getVersion (UVersionInfo info) const =0
| Gets the version information for a Collator.
virtual UClassID | getDynamicClassID (void) const =0
| Returns a unique class ID POLYMORPHICALLY.
virtual void | setAttribute (UColAttribute attr, UColAttributeValue value, UErrorCode &status)=0
| Universal attribute setter.
virtual UColAttributeValue | getAttribute (UColAttribute attr, UErrorCode &status)=0
| Universal attribute getter.
virtual uint32_t | setVariableTop (const UChar *varTop, int32_t len, UErrorCode &status)=0
| Sets the variable top to a collation element value of a string supplied.
virtual uint32_t | setVariableTop (const UnicodeString varTop, UErrorCode &status)=0
| Sets the variable top to a collation element value of a string supplied.
virtual void | setVariableTop (const uint32_t varTop, UErrorCode &status)=0
| Sets the variable top to a collation element value supplied.
virtual uint32_t | getVariableTop (UErrorCode &status) const =0
| Gets the variable top value of a Collator.
virtual UnicodeSet * | getTailoredSet (UErrorCode &status) const
| Get an UnicodeSet that contains all the characters and sequences tailored in this collator.
virtual Collator * | safeClone (void)=0
| Thread safe cloning operation.
virtual int32_t | getSortKey (const UnicodeString &source, uint8_t *result, int32_t resultLength) const =0
| Get the sort key as an array of bytes from an UnicodeString.
virtual int32_t | getSortKey (const UChar *source, int32_t sourceLength, uint8_t *result, int32_t resultLength) const =0
| Get the sort key as an array of bytes from an UChar buffer.
## Static Public Member Functions
static Collator * | createInstance (UErrorCode &err)
| Creates the Collator object for the current default locale.
static Collator * | createInstance (const Locale &loc, UErrorCode &err)
| Gets the table-based collation object for the desired locale.
static UnicodeString & | getDisplayName (const Locale &objectLocale, const Locale &displayLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the desired langauge.
static UnicodeString & | getDisplayName (const Locale &objectLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the langauge of the default locale.
static const Locale * | getAvailableLocales (int32_t &count)
| Get the set of Locales for which Collations are installed.
static StringEnumeration * | getAvailableLocales (void)
| Return a StringEnumeration over the locales available at the time of the call, including registered locales.
static StringEnumeration * | getKeywords (UErrorCode &status)
| Create a string enumerator of all possible keywords that are relevant to collation.
static StringEnumeration * | getKeywordValues (const char *keyword, UErrorCode &status)
| Given a keyword, create a string enumeration of all values for that keyword that are currently in use.
static StringEnumeration * | getKeywordValuesForLocale (const char *keyword, const Locale &locale, UBool commonlyUsed, UErrorCode &status)
| Given a key and a locale, returns an array of string values in a preferred order that would make a difference.
static Locale | getFunctionalEquivalent (const char *keyword, const Locale &locale, UBool &isAvailable, UErrorCode &status)
| Return the functionally equivalent locale for the given requested locale, with respect to given keyword, for the collation service.
static URegistryKey | registerInstance (Collator *toAdopt, const Locale &locale, UErrorCode &status)
| Register a new Collator.
static URegistryKey | registerFactory (CollatorFactory *toAdopt, UErrorCode &status)
| Register a new CollatorFactory.
static UBool | unregister (URegistryKey key, UErrorCode &status)
| Unregister a previously-registered Collator or CollatorFactory using the key returned from the register call.
static int32_t | getBound (const uint8_t *source, int32_t sourceLength, UColBoundMode boundType, uint32_t noOfLevels, uint8_t *result, int32_t resultLength, UErrorCode &status)
| Produce a bound for a given sortkey and a number of levels.
static UCollator * | createUCollator (const char *loc, UErrorCode *status)
| used only by ucol_open, not for public use
## Protected Member Functions
| Collator ()
| Default constructor.
| Collator (UCollationStrength collationStrength, UNormalizationMode decompositionMode)
| Constructor.
| Collator (const Collator &other)
| Copy constructor.
virtual void | setLocales (const Locale &requestedLocale, const Locale &validLocale, const Locale &actualLocale)
| Used internally by registraton to define the requested and valid locales.
## Friends
class | CFactory
class | SimpleCFactory
class | ICUCollatorFactory
class | ICUCollatorService

## Detailed Description

The `Collator` class performs locale-sensitive string comparison.

You use this class to build searching and sorting routines for natural language text.
Important: The ICU collation service has been reimplemented in order to achieve better performance and UCA compliance. For details, see the collation design document.

`Collator` is an abstract base class. Subclasses implement specific collation strategies. One subclass, `RuleBasedCollator`, is currently provided and is applicable to a wide set of languages. Other subclasses may be created to handle more specialized needs.

Like other locale-sensitive classes, you can use the static factory method, `createInstance`, to obtain the appropriate `Collator` object for a given locale. You will only need to look at the subclasses of `Collator` if you need to understand the details of a particular collation strategy or if you need to modify that strategy.

The following example shows how to compare two strings using the `Collator` for the default locale.

>       // Compare two strings in the default locale
>      UErrorCode success = U_ZERO_ERROR;
>      Collator* myCollator = Collator::createInstance(success);
>      if (myCollator->compare("abc", "ABC") < 0)
>        cout << "abc is less than ABC" << endl;
>      else
>        cout << "abc is greater than or equal to ABC" << endl;

You can set a `Collator`'s strength property to determine the level of difference considered significant in comparisons. Five strengths are provided: `PRIMARY`, `SECONDARY`, `TERTIARY`, `QUATERNARY` and `IDENTICAL`. The exact assignment of strengths to language features is locale dependant. For example, in Czech, "e" and "f" are considered primary differences, while "e" and "\u00EA" are secondary differences, "e" and "E" are tertiary differences and "e" and "e" are identical. The following shows how both case and accents could be ignored for US English.

>       //Get the Collator for US English and set its strength to PRIMARY
>      UErrorCode success = U_ZERO_ERROR;
>      Collator* usCollator = Collator::createInstance(Locale::US, success);
>      usCollator->setStrength(Collator::PRIMARY);
>      if (usCollator->compare("abc", "ABC") == 0)
>          cout << "'abc' and 'ABC' strings are equivalent with strength PRIMARY" << endl;

For comparing strings exactly once, the `compare` method provides the best performance. When sorting a list of strings however, it is generally necessary to compare each string multiple times. In this case, sort keys provide better performance. The `getSortKey` methods convert a string to a series of bytes that can be compared bitwise against other sort keys using `strcmp()`. Sort keys are written as zero-terminated byte strings. They consist of several substrings, one for each collation strength level, that are delimited by 0x01 bytes. If the string code points are appended for UCOL_IDENTICAL, then they are processed for correct code point order comparison and may contain 0x01 bytes but not zero bytes.

An older set of APIs returns a `CollationKey` object that wraps the sort key bytes instead of returning the bytes themselves. Its use is deprecated, but it is still available for compatibility with Java.

Note: `Collator`s with different Locale, and CollationStrength settings will return different sort orders for the same set of strings. Locales have specific collation rules, and the way in which secondary and tertiary differences are taken into account, for example, will result in a different sorting order for same strings.

See also:
  RuleBasedCollator

  CollationKey

  CollationElementIterator

  Locale

  Normalizer

Version:
  2.0 11/15/01

Definition at line 177 of file coll.h.

## Member Enumeration Documentation

enum Collator::ECollationStrength

Base letter represents a primary difference.

Set comparison level to PRIMARY to ignore secondary and tertiary differences.
Use this to set the strength of a Collator object.
Example of primary difference, "abc" < "abd"

Diacritical differences on the same base letter represent a secondary difference. Set comparison level to SECONDARY to ignore tertiary differences. Use this to set the strength of a Collator object.
Example of secondary difference, "&auml;" >> "a".

Uppercase and lowercase versions of the same character represents a tertiary difference. Set comparison level to TERTIARY to include all comparison differences. Use this to set the strength of a Collator object.
Example of tertiary difference, "abc" <<< "ABC".

Two characters are considered "identical" when they have the same unicode spellings.
For example, "&auml;" == "&auml;".

UCollationStrength is also used to determine the strength of sort keys generated from Collator objects.

Stable:
  ICU 2.0

Definition at line 207 of file coll.h.

enum Collator::EComparisonResult

LESS is returned if source string is compared to be less than target string in the compare() method.

EQUAL is returned if source string is compared to be equal to target string in the compare() method. GREATER is returned if source string is compared to be greater than target string in the compare() method.

See also:
  Collator::compare

Deprecated:
  ICU 2.6. Use C enum UCollationResult defined in ucol.h

Definition at line 226 of file coll.h.

## Constructor & Destructor Documentation

virtual Collator::~Collator | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.0

Collator::Collator | ( |  | ) | `[protected]`

Default constructor.

Constructor is different from the old default Collator constructor. The task for determing the default collation strength and normalization mode is left to the child class.

Stable:
  ICU 2.0

Collator::Collator | ( | UCollationStrength | collationStrength,
|  | UNormalizationMode | decompositionMode |
| ) |  |  | `[protected]`

Constructor.

Empty constructor, does not handle the arguments. This constructor is done for backward compatibility with 1.7 and 1.8. The task for handling the argument collation strength and normalization mode is left to the child class.

Parameters:

  | collationStrength | collation strength
  | decompositionMode |

Deprecated:
  ICU 2.4. Subclasses should use the default constructor instead and handle the strength and normalization mode themselves.

Collator::Collator | ( | const Collator & | other | ) | `[protected]`

Copy constructor.

Parameters:

  | other | Collator object to be copied from

Stable:
  ICU 2.0

## Member Function Documentation

virtual Collator* Collator::clone | ( | void |  | ) | const`[pure virtual]`

Makes a shallow copy of the current object.

Returns:
  a copy of this object

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

virtual UCollationResult Collator::compare | ( | UCharIterator & | sIter,
|  | UCharIterator & | tIter,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Compares two strings using the Collator.

Returns whether the first one compares less than/equal to/greater than the second one. This version takes UCharIterator input.

Parameters:

  | sIter | the first ("source") string iterator
  | tIter | the second ("target") string iterator
  | status | ICU status

Returns:
  UCOL_LESS, UCOL_EQUAL or UCOL_GREATER

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.2

Reimplemented in RuleBasedCollator.

virtual UCollationResult Collator::compare | ( | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

The comparison function compares the character data stored in two different string arrays.

Returns information about whether a string array is less than, greater than or equal to another string array.

Parameters:

  | source | the source string array to be compared with.
  | sourceLength | the length of the source string array. If this value is equal to -1, the string array is null-terminated.
  | target | the string that is to be compared with the source string.
  | targetLength | the length of the target string array. If this value is equal to -1, the string array is null-terminated.
  | status | possible error code

Returns:
  Returns an enum value. UCOL_GREATER if source is greater than target; UCOL_EQUAL if source is equal to target; UCOL_LESS if source is less than target

Stable:
  ICU 2.6

Implemented in RuleBasedCollator.

virtual EComparisonResult Collator::compare | ( | const UChar * | source,
|  | int32_t | sourceLength,
|  | const UChar * | target,
|  | int32_t | targetLength |
| ) |  |  | const`[virtual]`

The comparison function compares the character data stored in two different string arrays.

Returns information about whether a string array is less than, greater than or equal to another string array.

Parameters:

  | source | the source string array to be compared with.
  | sourceLength | the length of the source string array. If this value is equal to -1, the string array is null-terminated.
  | target | the string that is to be compared with the source string.
  | targetLength | the length of the target string array. If this value is equal to -1, the string array is null-terminated.

Returns:
  Returns a byte value. GREATER if source is greater than target; EQUAL if source is equal to target; LESS if source is less than target

Deprecated:
  ICU 2.6 use the overload with UErrorCode &

Reimplemented in RuleBasedCollator.

virtual UCollationResult Collator::compare | ( | const UnicodeString & | source,
|  | const UnicodeString & | target,
|  | int32_t | length,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Does the same thing as compare but limits the comparison to a specified length.

Parameters:

  | source | the source string to be compared with.
  | target | the string that is to be compared with the source string.
  | length | the length the comparison is limited to
  | status | possible error code

Returns:
  Returns an enum value. UCOL_GREATER if source (up to the specified length) is greater than target; UCOL_EQUAL if source (up to specified length) is equal to target; UCOL_LESS if source (up to the specified length) is less than target.

Stable:
  ICU 2.6

Implemented in RuleBasedCollator.

virtual EComparisonResult Collator::compare | ( | const UnicodeString & | source,
|  | const UnicodeString & | target,
|  | int32_t | length |
| ) |  |  | const`[virtual]`

Does the same thing as compare but limits the comparison to a specified length.

Parameters:

  | source | the source string to be compared with.
  | target | the string that is to be compared with the source string.
  | length | the length the comparison is limited to

Returns:
  Returns a byte value. GREATER if source (up to the specified length) is greater than target; EQUAL if source (up to specified length) is equal to target; LESS if source (up to the specified length) is less than target.

Deprecated:
  ICU 2.6 use the overload with UErrorCode &

Reimplemented in RuleBasedCollator.

virtual UCollationResult Collator::compare | ( | const UnicodeString & | source,
|  | const UnicodeString & | target,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

The comparison function compares the character data stored in two different strings.

Returns information about whether a string is less than, greater than or equal to another string.

Parameters:

  | source | the source string to be compared with.
  | target | the string that is to be compared with the source string.
  | status | possible error code

Returns:
  Returns an enum value. UCOL_GREATER if source is greater than target; UCOL_EQUAL if source is equal to target; UCOL_LESS if source is less than target

Stable:
  ICU 2.6

Implemented in RuleBasedCollator.

virtual EComparisonResult Collator::compare | ( | const UnicodeString & | source,
|  | const UnicodeString & | target |
| ) |  |  | const`[virtual]`

The comparison function compares the character data stored in two different strings.

Returns information about whether a string is less than, greater than or equal to another string.

Parameters:

  | source | the source string to be compared with.
  | target | the string that is to be compared with the source string.

Returns:
  Returns a byte value. GREATER if source is greater than target; EQUAL if source is equal to target; LESS if source is less than target

Deprecated:
  ICU 2.6 use the overload with UErrorCode &

Reimplemented in RuleBasedCollator.

virtual UCollationResult Collator::compareUTF8 | ( | const StringPiece & | source,
|  | const StringPiece & | target,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Compares two UTF-8 strings using the Collator.

Returns whether the first one compares less than/equal to/greater than the second one. This version takes UTF-8 input. Note that a StringPiece can be implicitly constructed from a std::string or a NUL-terminated const char * string.

Parameters:

  | source | the first UTF-8 string
  | target | the second UTF-8 string
  | status | ICU status

Returns:
  UCOL_LESS, UCOL_EQUAL or UCOL_GREATER

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.2

static Collator* Collator::createInstance | ( | const Locale & | loc,
|  | UErrorCode & | err |
| ) |  |  | `[static]`

Gets the table-based collation object for the desired locale.

The resource of the desired locale will be loaded by ResourceLoader. Locale::ENGLISH is the base collation table and all other languages are built on top of it with additional language-specific modifications. The UErrorCode& err parameter is used to return status information to the user. To check whether the construction succeeded or not, you should check the value of U_SUCCESS(err). If you wish more detailed information, you can check for informational error results which still indicate success. U_USING_FALLBACK_ERROR indicates that a fall back locale was used. For example, 'de_CH' was requested, but nothing was found there, so 'de' was used. U_USING_DEFAULT_ERROR indicates that the default locale data was used; neither the requested locale nor any of its fall back locales could be found. The caller owns the returned object and is responsible for deleting it.

Parameters:

  | loc | The locale ID for which to open a collator.
  | err | the error code status.

Returns:
  the created table-based collation object based on the desired locale.

See also:
  Locale

  ResourceLoader

Stable:
  ICU 2.2

static Collator* Collator::createInstance | ( | UErrorCode & | err | ) | `[static]`

Creates the Collator object for the current default locale.

The default locale is determined by Locale::getDefault. The UErrorCode& err parameter is used to return status information to the user. To check whether the construction succeeded or not, you should check the value of U_SUCCESS(err). If you wish more detailed information, you can check for informational error results which still indicate success. U_USING_FALLBACK_ERROR indicates that a fall back locale was used. For example, 'de_CH' was requested, but nothing was found there, so 'de' was used. U_USING_DEFAULT_ERROR indicates that the default locale data was used; neither the requested locale nor any of its fall back locales could be found. The caller owns the returned object and is responsible for deleting it.

Parameters:

  | err | the error code status.

Returns:
  the collation object of the default locale.(for example, en_US)

See also:
  Locale::getDefault

Stable:
  ICU 2.0

static UCollator* Collator::createUCollator | ( | const char * | loc,
|  | UErrorCode * | status |
| ) |  |  | `[static]`

used only by ucol_open, not for public use

Internal:
  Do not use. This API is for internal use only.

UBool Collator::equals | ( | const UnicodeString & | source,
|  | const UnicodeString & | target |
| ) |  |  | const

Convenience method for comparing two strings based on the collation rules.

Parameters:

  | source | the source string to be compared with.
  | target | the target string to be compared with.

Returns:
  true if the strings are equal according to the collation rules. false, otherwise.

See also:
  Collator::compare

Stable:
  ICU 2.0

virtual UColAttributeValue Collator::getAttribute | ( | UColAttribute | attr,
|  | UErrorCode & | status |
| ) |  |  | `[pure virtual]`

Universal attribute getter.

Parameters:

  | attr | attribute type
  | status | to indicate whether the operation went on smoothly or there were errors

Returns:
  attribute value

Stable:
  ICU 2.2

Implemented in RuleBasedCollator.

static StringEnumeration* Collator::getAvailableLocales | ( | void |  | ) | `[static]`

Return a StringEnumeration over the locales available at the time of the call, including registered locales.

If a severe error occurs (such as out of memory condition) this will return null. If there is no locale data, an empty enumeration will be returned.

Returns:
  a StringEnumeration over the locales available at the time of the call

Stable:
  ICU 2.6

static const Locale* Collator::getAvailableLocales | ( | int32_t & | count | ) | `[static]`

Get the set of Locales for which Collations are installed.

Note this does not include locales supported by registered collators. If collators might have been registered, use the overload of getAvailableLocales that returns a StringEnumeration.

Parameters:

  | count | the output parameter of number of elements in the locale list

Returns:
  the list of available locales for which collations are installed

Stable:
  ICU 2.0

static int32_t Collator::getBound | ( | const uint8_t * | source,
|  | int32_t | sourceLength,
|  | UColBoundMode | boundType,
|  | uint32_t | noOfLevels,
|  | uint8_t * | result,
|  | int32_t | resultLength,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Produce a bound for a given sortkey and a number of levels.

Return value is always the number of bytes needed, regardless of whether the result buffer was big enough or even valid.
Resulting bounds can be used to produce a range of strings that are between upper and lower bounds. For example, if bounds are produced for a sortkey of string "smith", strings between upper and lower bounds with one level would include "Smith", "SMITH", "sMiTh".
There are two upper bounds that can be produced. If UCOL_BOUND_UPPER is produced, strings matched would be as above. However, if bound produced using UCOL_BOUND_UPPER_LONG is used, the above example will also match "Smithsonian" and similar.
For more on usage, see example in cintltst/capitst.c in procedure TestBounds. Sort keys may be compared using `strcmp`.

Parameters:

  | source | The source sortkey.
  | sourceLength | The length of source, or -1 if null-terminated. (If an unmodified sortkey is passed, it is always null terminated).
  | boundType | Type of bound required. It can be UCOL_BOUND_LOWER, which produces a lower inclusive bound, UCOL_BOUND_UPPER, that produces upper bound that matches strings of the same length or UCOL_BOUND_UPPER_LONG that matches strings that have the same starting substring as the source string.
  | noOfLevels | Number of levels required in the resulting bound (for most uses, the recommended value is 1). See users guide for explanation on number of levels a sortkey can have.
  | result | A pointer to a buffer to receive the resulting sortkey.
  | resultLength | The maximum size of result.
  | status | Used for returning error code if something went wrong. If the number of levels requested is higher than the number of levels in the source key, a warning (U_SORT_KEY_TOO_SHORT_WARNING) is issued.

Returns:
  The size needed to fully store the bound.

See also:
  ucol_keyHashCode

Stable:
  ICU 2.1

virtual CollationKey& Collator::getCollationKey | ( | const UChar * | source,
|  | int32_t | sourceLength,
|  | CollationKey & | key,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Transforms the string into a series of characters that can be compared with CollationKey::compareTo.

It is not possible to restore the original string from the chars in the sort key. The generated sort key handles only a limited number of ignorable characters.

Use CollationKey::equals or CollationKey::compare to compare the generated sort keys.

If the source string is null, a null collation key will be returned.

Parameters:

  | source | the source string to be transformed into a sort key.
  | sourceLength | length of the collation key
  | key | the collation key to be filled in
  | status | the error code status.

Returns:
  the collation key of the string based on the collation rules.

See also:
  CollationKey::compare

Deprecated:
  ICU 2.8 Use getSortKey(...) instead

Implemented in RuleBasedCollator.

virtual CollationKey& Collator::getCollationKey | ( | const UnicodeString & | source,
|  | CollationKey & | key,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Transforms the string into a series of characters that can be compared with CollationKey::compareTo.

It is not possible to restore the original string from the chars in the sort key. The generated sort key handles only a limited number of ignorable characters.

Use CollationKey::equals or CollationKey::compare to compare the generated sort keys. If the source string is null, a null collation key will be returned.

Parameters:

  | source | the source string to be transformed into a sort key.
  | key | the collation key to be filled in
  | status | the error code status.

Returns:
  the collation key of the string based on the collation rules.

See also:
  CollationKey::compare

Deprecated:
  ICU 2.8 Use getSortKey(...) instead

Implemented in RuleBasedCollator.

static UnicodeString& Collator::getDisplayName | ( | const Locale & | objectLocale,
|  | UnicodeString & | name |
| ) |  |  | `[static]`

Get name of the object for the desired Locale, in the langauge of the default locale.

Parameters:

  | objectLocale | must be from getAvailableLocales
  | name | the fill-in parameter of the return value

Returns:
  name of the object for the desired locale in the default language

Stable:
  ICU 2.0

static UnicodeString& Collator::getDisplayName | ( | const Locale & | objectLocale,
|  | const Locale & | displayLocale,
|  | UnicodeString & | name |
| ) |  |  | `[static]`

Get name of the object for the desired Locale, in the desired langauge.

Parameters:

  | objectLocale | must be from getAvailableLocales
  | displayLocale | specifies the desired locale for output
  | name | the fill-in parameter of the return value

Returns:
  display-able name of the object for the object locale in the desired language

Stable:
  ICU 2.0

virtual UClassID Collator::getDynamicClassID | ( | void |  | ) | const`[pure virtual]`

Returns a unique class ID POLYMORPHICALLY.

Pure virtual method. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns:
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements UObject.

Implemented in RuleBasedCollator.

static Locale Collator::getFunctionalEquivalent | ( | const char * | keyword,
|  | const Locale & | locale,
|  | UBool & | isAvailable,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Return the functionally equivalent locale for the given requested locale, with respect to given keyword, for the collation service.

If two locales return the same result, then collators instantiated for these locales will behave equivalently. The converse is not always true; two collators may in fact be equivalent, but return different results, due to internal details. The return result has no other meaning than that stated above, and implies nothing as to the relationship between the two locales. This is intended for use by applications who wish to cache collators, or otherwise reuse collators when possible. The functional equivalent may change over time. For more information, please see the Locales and Services section of the ICU User Guide.

Parameters:

  | keyword | a particular keyword as enumerated by ucol_getKeywords.
  | locale | the requested locale
  | isAvailable | reference to a fillin parameter that indicates whether the requested locale was 'available' to the collation service. A locale is defined as 'available' if it physically exists within the collation locale data.
  | status | reference to input-output error code

Returns:
  the functionally equivalent collation locale, or the root locale upon error.

Stable:
  ICU 3.0

static StringEnumeration* Collator::getKeywords | ( | UErrorCode & | status | ) | `[static]`

Create a string enumerator of all possible keywords that are relevant to collation.

At this point, the only recognized keyword for this service is "collation".

Parameters:

  | status | input-output error code

Returns:
  a string enumeration over locale strings. The caller is responsible for closing the result.

Stable:
  ICU 3.0

static StringEnumeration* Collator::getKeywordValues | ( | const char * | keyword,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Given a keyword, create a string enumeration of all values for that keyword that are currently in use.

Parameters:

  | keyword | a particular keyword as enumerated by ucol_getKeywords. If any other keyword is passed in, status is set to U_ILLEGAL_ARGUMENT_ERROR.
  | status | input-output error code

Returns:
  a string enumeration over collation keyword values, or NULL upon error. The caller is responsible for deleting the result.

Stable:
  ICU 3.0

static StringEnumeration* Collator::getKeywordValuesForLocale | ( | const char * | keyword,
|  | const Locale & | locale,
|  | UBool | commonlyUsed,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Given a key and a locale, returns an array of string values in a preferred order that would make a difference.

These are all and only those values where the open (creation) of the service with the locale formed from the input locale plus input keyword and that value has different behavior than creation with the input locale alone.

Parameters:

  | keyword | one of the keys supported by this service. For now, only "collation" is supported.
  | locale | the locale
  | commonlyUsed | if set to true it will return only commonly used values with the given locale in preferred order. Otherwise, it will return all the available values for the locale.
  | status | ICU status

Returns:
  a string enumeration over keyword values for the given key and the locale.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.2

virtual const Locale Collator::getLocale | ( | ULocDataLocaleType | type,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Gets the locale of the Collator.

Parameters:

  | type | can be either requested, valid or actual locale. For more information see the definition of ULocDataLocaleType in uloc.h
  | status | the error code status.

Returns:
  locale where the collation data lives. If the collator was instantiated from rules, locale is empty.

Deprecated:
  ICU 2.8 This API is under consideration for revision in ICU 3.0.

Implemented in RuleBasedCollator.

virtual int32_t Collator::getSortKey | ( | const UChar * | source,
|  | int32_t | sourceLength,
|  | uint8_t * | result,
|  | int32_t | resultLength |
| ) |  |  | const`[pure virtual]`

Get the sort key as an array of bytes from an UChar buffer.

Sort key byte arrays are zero-terminated and can be compared using strcmp().

Parameters:

  | source | string to be processed.
  | sourceLength | length of string to be processed. If -1, the string is 0 terminated and length will be decided by the function.
  | result | buffer to store result in. If NULL, number of bytes needed will be returned.
  | resultLength | length of the result buffer. If if not enough the buffer will be filled to capacity.

Returns:
  Number of bytes needed for storing the sort key

Stable:
  ICU 2.2

Implemented in RuleBasedCollator.

virtual int32_t Collator::getSortKey | ( | const UnicodeString & | source,
|  | uint8_t * | result,
|  | int32_t | resultLength |
| ) |  |  | const`[pure virtual]`

Get the sort key as an array of bytes from an UnicodeString.

Sort key byte arrays are zero-terminated and can be compared using strcmp().

Parameters:

  | source | string to be processed.
  | result | buffer to store result in. If NULL, number of bytes needed will be returned.
  | resultLength | length of the result buffer. If if not enough the buffer will be filled to capacity.

Returns:
  Number of bytes needed for storing the sort key

Stable:
  ICU 2.2

Implemented in RuleBasedCollator.

virtual ECollationStrength Collator::getStrength | ( | void |  | ) | const`[pure virtual]`

Determines the minimum strength that will be use in comparison or transformation.

E.g. with strength == SECONDARY, the tertiary difference is ignored

E.g. with strength == PRIMARY, the secondary and tertiary difference are ignored.

Returns:
  the current comparison level.

See also:
  Collator::setStrength

Deprecated:
  ICU 2.6 Use getAttribute(UCOL_STRENGTH...) instead

Implemented in RuleBasedCollator.

virtual UnicodeSet* Collator::getTailoredSet | ( | UErrorCode & | status | ) | const`[virtual]`

Get an UnicodeSet that contains all the characters and sequences tailored in this collator.

Parameters:

  | status | error code of the operation

Returns:
  a pointer to a UnicodeSet object containing all the code points and sequences that may sort differently than in the UCA. The object must be disposed of by using delete

Stable:
  ICU 2.4

Reimplemented in RuleBasedCollator.

virtual uint32_t Collator::getVariableTop | ( | UErrorCode & | status | ) | const`[pure virtual]`

Gets the variable top value of a Collator.

Lower 16 bits are undefined and should be ignored.

Parameters:

  | status | error code (not changed by function). If error code is set, the return value is undefined.

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

virtual void Collator::getVersion | ( | UVersionInfo | info | ) | const`[pure virtual]`

Gets the version information for a Collator.

Parameters:

  | info | the version # information, the result will be filled in

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

UBool Collator::greater | ( | const UnicodeString & | source,
|  | const UnicodeString & | target |
| ) |  |  | const

Convenience method for comparing two strings based on the collation rules.

Parameters:

  | source | the source string to be compared with.
  | target | the target string to be compared with.

Returns:
  true if the first string is greater than the second one, according to the collation rules. false, otherwise.

See also:
  Collator::compare

Stable:
  ICU 2.0

UBool Collator::greaterOrEqual | ( | const UnicodeString & | source,
|  | const UnicodeString & | target |
| ) |  |  | const

Convenience method for comparing two strings based on the collation rules.

Parameters:

  | source | the source string to be compared with.
  | target | the target string to be compared with.

Returns:
  true if the first string is greater than or equal to the second one, according to the collation rules. false, otherwise.

See also:
  Collator::compare

Stable:
  ICU 2.0

virtual int32_t Collator::hashCode | ( | void |  | ) | const`[pure virtual]`

Generates the hash code for the collation object.

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

virtual UBool Collator::operator!= | ( | const Collator & | other | ) | const`[virtual]`

Returns true if "other" is not the same as "this".

Parameters:

  | other | Collator object to be compared

Returns:
  true if other is not the same as this.

Stable:
  ICU 2.0

Reimplemented in RuleBasedCollator.

virtual UBool Collator::operator== | ( | const Collator & | other | ) | const`[virtual]`

Returns true if "other" is the same as "this".

Parameters:

  | other | Collator object to be compared

Returns:
  true if other is the same as this.

Stable:
  ICU 2.0

Reimplemented in RuleBasedCollator.

static URegistryKey Collator::registerFactory | ( | CollatorFactory * | toAdopt,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Register a new CollatorFactory.

The factory will be adopted.

Parameters:

  | toAdopt | the CollatorFactory instance to be adopted
  | status | the in/out status code, no special meanings are assigned

Returns:
  a registry key that can be used to unregister this collator

Stable:
  ICU 2.6

static URegistryKey Collator::registerInstance | ( | Collator * | toAdopt,
|  | const Locale & | locale,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Register a new Collator.

The collator will be adopted.

Parameters:

  | toAdopt | the Collator instance to be adopted
  | locale | the locale with which the collator will be associated
  | status | the in/out status code, no special meanings are assigned

Returns:
  a registry key that can be used to unregister this collator

Stable:
  ICU 2.6

virtual Collator* Collator::safeClone | ( | void |  | ) | `[pure virtual]`

Thread safe cloning operation.

Returns:
  pointer to the new clone, user should remove it.

Stable:
  ICU 2.2

Implemented in RuleBasedCollator.

virtual void Collator::setAttribute | ( | UColAttribute | attr,
|  | UColAttributeValue | value,
|  | UErrorCode & | status |
| ) |  |  | `[pure virtual]`

Universal attribute setter.

Parameters:

  | attr | attribute type
  | value | attribute value
  | status | to indicate whether the operation went on smoothly or there were errors

Stable:
  ICU 2.2

Implemented in RuleBasedCollator.

virtual void Collator::setLocales | ( | const Locale & | requestedLocale,
|  | const Locale & | validLocale,
|  | const Locale & | actualLocale |
| ) |  |  | `[protected, virtual]`

Used internally by registraton to define the requested and valid locales.

Parameters:

  | requestedLocale | the requested locale
  | validLocale | the valid locale
  | actualLocale | the actual locale

Internal:
  Do not use. This API is for internal use only.

Reimplemented in RuleBasedCollator.

virtual void Collator::setStrength | ( | ECollationStrength | newStrength | ) | `[pure virtual]`

Sets the minimum strength to be used in comparison or transformation.

Example of use:

        UErrorCode status = U_ZERO_ERROR;
      Collator*myCollation = Collator::createInstance(Locale::US, status);
      if (U_FAILURE(status)) return;
      myCollation->setStrength(Collator::PRIMARY);
      // result will be "abc" == "ABC"
      // tertiary differences will be ignored
      Collator::ComparisonResult result = myCollation->compare("abc", "ABC");

See also:
  Collator::getStrength

Parameters:

  | newStrength | the new comparison level.

Deprecated:
  ICU 2.6 Use setAttribute(UCOL_STRENGTH...) instead

Implemented in RuleBasedCollator.

virtual void Collator::setVariableTop | ( | const uint32_t | varTop,
|  | UErrorCode & | status |
| ) |  |  | `[pure virtual]`

Sets the variable top to a collation element value supplied.

Variable top is set to the upper 16 bits. Lower 16 bits are ignored.

Parameters:

  | varTop | CE value, as returned by setVariableTop or ucol)getVariableTop
  | status | error code (not changed by function)

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

virtual uint32_t Collator::setVariableTop | ( | const UnicodeString | varTop,
|  | UErrorCode & | status |
| ) |  |  | `[pure virtual]`

Sets the variable top to a collation element value of a string supplied.

Parameters:

  | varTop | an UnicodeString size 1 or more (if contraction) of UChars to which the variable top should be set
  | status | error code. If error code is set, the return value is undefined. Errors set by this function are: U_CE_NOT_FOUND_ERROR if more than one character was passed and there is no such a contraction U_PRIMARY_TOO_LONG_ERROR if the primary for the variable top has more than two bytes

Returns:
  a 32 bit value containing the value of the variable top in upper 16 bits. Lower 16 bits are undefined

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

virtual uint32_t Collator::setVariableTop | ( | const UChar * | varTop,
|  | int32_t | len,
|  | UErrorCode & | status |
| ) |  |  | `[pure virtual]`

Sets the variable top to a collation element value of a string supplied.

Parameters:

  | varTop | one or more (if contraction) UChars to which the variable top should be set
  | len | length of variable top string. If -1 it is considered to be zero terminated.
  | status | error code. If error code is set, the return value is undefined. Errors set by this function are: U_CE_NOT_FOUND_ERROR if more than one character was passed and there is no such a contraction U_PRIMARY_TOO_LONG_ERROR if the primary for the variable top has more than two bytes

Returns:
  a 32 bit value containing the value of the variable top in upper 16 bits. Lower 16 bits are undefined

Stable:
  ICU 2.0

Implemented in RuleBasedCollator.

static UBool Collator::unregister | ( | URegistryKey | key,
|  | UErrorCode & | status |
| ) |  |  | `[static]`

Unregister a previously-registered Collator or CollatorFactory using the key returned from the register call.

Key becomes invalid after a successful call and should not be used again. The object corresponding to the key will be deleted.

Parameters:

  | key | the registry key returned by a previous call to registerInstance
  | status | the in/out status code, no special meanings are assigned

Returns:
  TRUE if the collator for the key was successfully unregistered

Stable:
  ICU 2.6

The documentation for this class was generated from the following file:

- coll.h